import pitaru.sonia_v2_9.*;
import oscP5.*;
import netP5.*;
import controlP5.*;

ControlP5 controlP5;
boolean toggleEnvelope = false;
boolean toggleEqualizer = false;
boolean toggleVisualEQ = true;
float EnvelopeAdjustValue = 1.5;
float DampingAdjustValue = 1.0;

OscP5 oscP5;
NetAddress myRemoteLocation;

int fft_bands = 32;
int screenwidth = 320;
float offsetX = screenwidth/fft_bands;

color c1 = #FF0000;
color c2 = #FFFFFF;
color c3 = #666666;
color c4 = #CCCCCC;

void setup(){
  smooth();
  controlP5 = new ControlP5(this);
  controlP5.setColorActive(c1);
  controlP5.setColorLabel(c2);
  controlP5.setColorForeground(c2);
  controlP5.setColorBackground(c4);
  controlP5.addToggle("Envelope",false,10,10,10,10);
  controlP5.addToggle("Equalizer",false,60,10,10,10);
  controlP5.addToggle("EQ_ON",true,280,10,10,10);
  Slider s = controlP5.addSlider("EnvelopeAdjust",0.0,10.0,1.5,10,40,10,100);
  s = controlP5.addSlider("Damping",0.05,2.0,1.0,280,40,10,100);

  size(screenwidth,240);
  strokeCap(SQUARE);
  frameRate(25);
  Sonia.start(this);
  LiveInput.start(fft_bands);

  /* start oscP5, listening for incoming messages at port 8002 */
  oscP5 = new OscP5(this,8002);
  myRemoteLocation = new NetAddress("127.0.0.1",8002);
  //myRemoteLocation = new NetAddress("192.168.178.20",8002);
}

void draw(){
  background(0,0,0);
  //getSpectrum();
  if(toggleVisualEQ==true) {
    getSpectrum();
  }
  else {
    getValues();
  }
}

void getSpectrum(){
  strokeWeight(offsetX*0.5);
  stroke(c3);

  OscMessage myMessage = new OscMessage("/md8key");
  LiveInput.getSpectrum();
  //LiveInput.getSpectrum(true,1.2);
  LiveInput.useEnvelope(toggleEnvelope,EnvelopeAdjustValue);
  LiveInput.useEqualizer(toggleEqualizer);
  for (int i = 0; i < LiveInput.spectrum.length; i++){
    line(i*offsetX+offsetX*0.5, height, i*offsetX+offsetX*0.5, height - LiveInput.spectrum[i]*DampingAdjustValue);
    float data = LiveInput.spectrum[i]*DampingAdjustValue;
    myMessage.add(data);
  }
  oscP5.send(myMessage, myRemoteLocation);
  myMessage.clear();
}
void getValues(){
  OscMessage myMessage = new OscMessage("/md8key");
  LiveInput.getSpectrum();
  LiveInput.useEnvelope(toggleEnvelope,EnvelopeAdjustValue);
  LiveInput.useEqualizer(toggleEqualizer);
  for (int i = 0; i < LiveInput.spectrum.length; i++){
    float data = LiveInput.spectrum[i]*DampingAdjustValue;
    myMessage.add(data);
  }
  oscP5.send(myMessage, myRemoteLocation);
  myMessage.clear();
}

public void stop(){
  Sonia.stop();
  super.stop();
}

void Envelope(boolean EnvelopeFlag) {
  if(EnvelopeFlag==true) {
    toggleEnvelope = true;
  }
  else {
    toggleEnvelope = false;
  }
}
void Equalizer(boolean EqualizerFlag) {
  if(EqualizerFlag==true) {
    toggleEqualizer = true;
  }
  else {
    toggleEqualizer = false;
  }
}
void EQ_ON(boolean VisualEQFlag) {
  if(VisualEQFlag==true) {
    toggleVisualEQ = true;
  }
  else {
    toggleVisualEQ = false;
  }
}
void EnvelopeAdjust(float EnvelopeValue) {
  EnvelopeAdjustValue = EnvelopeValue;
}
void Damping(float DampingValue) {
  DampingAdjustValue = DampingValue;
}

